#------------Library FILE--------------------------------------------#
sub lock
{
	local($file) = shift;
	$lock_file = "$file.bak";
	$locktime = time + 20;
	while (-e $lock_file && time < $locktime) {}
	open (LOCK,">$lock_file");
	chmod 0666,$lock_file;
	$locked = 'y';
}

sub unlock
{
	local($file) = shift;
	$lock_file = "$file.bak";
	if ($locked eq 'y') 
		 {
		  close (LOCK);
		  if (-e $lock_file) {unlink ("$lock_file");}
	     }
    $locked = 'n'; 
}

sub t_lock
{
	local ($kind,$tlock_file,$tlocktime);
	$kind = shift;
	if    ($kind eq 'n') {$tlock_file = "$real_dir/notice/check.cc";}
    elsif ($kind eq 'w') {$tlock_file = "$real_dir/check.cc";}
    elsif ($kind eq 'm') {$tlock_file = "$member_dir/check.cc";}

	$tlocktime = time + 20;
	while (-e $tlock_file && time < $tlocktime) {}
	open (WLOCK,">$tlock_file");
	chmod 0666,$tlock_file;
	$tlocked = 'y';
}

sub t_unlock
{
	local ($kind,$tlock_file,$tlocktime);
	$kind = shift;
	if    ($kind eq 'n') {$tlock_file = "$real_dir/notice/check.cc";}
    elsif ($kind eq 'w') {$tlock_file = "$real_dir/check.cc";}
    elsif ($kind eq 'm') {$tlock_file = "$member_dir/check.cc";}
	if ($tlocked eq 'y') 
		 {
		  close (WLOCK);
		  if (-e $tlock_file) {unlink ("$tlock_file");}
	     }
    $tlocked = 'n';
}


sub encode 
{
 local $encode = shift;
 $encode =~ s/\%/\%25/g;
 $encode =~ s/\=/\%3D/g;
 $encode =~ s/\&/\%26/g;
 $encode =~ s/\//\%2F/g;
 $encode =~ s/\#/\%23/g;
 $encode =~ s/\+/\%2B/g;
 $encode =~ s/\:/\%3A/g;
 $encode =~ s/\</\%3C/g;
 $encode =~ s/\\/\%5C/g;
 $encode =~ s/\>/\%3E/g;
 $encode =~ s/\|/\%7C/g;
 return $encode;
} 

sub decode {
 local $decode = shift;
 $decode =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 return $decode;
}


sub reload 
{
if (!$action) {$action ="$advn_scrt";}
&header;
print "<meta http-equiv=refresh content=1;url=$action>\n";
&footer;
exit;
}


sub noskin_reload 
{
if (!$action) {$action ="$cgi_url?id=$form{'id'}";}
&color_load;
&admin_header;
print "<meta http-equiv=refresh content=1;url=$action>\n";
&footer;
exit;
}

sub jumin_check { 
$jumin = shift =~ /(.)(.)(.)(.)(.)(.)-?(.)(.)(.)(.)(.)(.)(.)/; 
$jumin = ($1*2)+($2*3)+($3*4)+($4*5)+($5*6)+($6*7)+($7*8)+($8*9)+($9*2)+($10*3)+($11*4)+($12*5); 
$jumin %= 10 if ($jumin = 11- ($jumin % 11)) > 9; return 1 if $13 == $jumin; 

}

sub file_icon {
local (@filesplit,$icon_no);
if    ($link_filename) {@filesplit = split(/\./,$link_filename);}
elsif ($filename)      {@filesplit = split(/\./,$filename);}
$icon_no = @filesplit;
$icon = $filesplit[$icon_no-1];
if ($icon eq "gif" || $icon eq "bmp" || $icon eq  "gif" || $icon eq  "jpg" || $icon eq  "jpeg" || $icon eq  "pcx" || $icon eq  "png" || $icon eq  "tif" || $icon eq "GIF" || $icon eq "BMP" || $icon eq  "GIF" || $icon eq  "JPG" || $icon eq  "JPEG" || $icon eq  "PCX" || $icon eq  "PNG" || $icon eq  "TIF")
{$icon_t = "$icon_url/pic.gif";}
elsif ($icon eq "bat" || $icon eq "com" || $icon eq "exe")
{$icon_t = "$icon_url/exe.gif";}
elsif ($icon eq "txt" || $icon eq "hwp" || $icon eq "doc" || $icon eq "xls" || $icon eq "cap" || $icon eq "gal" || $icon eq "TXT" || $icon eq "HWP" || $icon eq "DOC" || $icon eq "CAP" || $icon eq "GAL" || $icon eq "XLS")
{$icon_t = "$icon_url/doc.gif";}
elsif ($icon eq "html" ||$icon eq "htm" || $icon eq "HTML" ||$icon eq "HTM")
{$icon_t = "$icon_url/htm.gif";}
elsif ($icon eq "mp3" || $icon eq "mp2" || $icon eq "wax" || $icon eq "aac" || $icon eq "voc" || $icon eq "aa3" ||$icon eq "MP3" || $icon eq "MP2" || $icon eq "WAX" || $icon eq "AAC" || $icon eq "VOC" || $icon eq "AA3" )
{$icon_t = "$icon_url/wav.gif";}
elsif ($icon eq "mp3" || $icon eq "mp2" ||$icon eq "MP3" || $icon eq "MP2")
{$icon_t = "$icon_url/mp3.gif";}
elsif ($icon eq "mid" || $icon eq "s3m" || $icon eq "mod" || $icon eq "rol" || $icon eq "ims" || $icon eq "wrk" || $icon eq "MID" || $icon eq "S3M" || $icon eq "MOD" || $icon eq "ROL" || $icon eq "IMS" || $icon eq "WRK")
{$icon_t = "$icon_url/mid.gif";}
elsif ($icon eq "ra" ||$icon eq "ram" || $icon eq "RA" ||$icon eq "RAM" || $icon eq "rm" || $icon eq "RM")
{$icon_t = "$icon_url/ra.gif";}
elsif ($icon eq "mov" ||$icon eq "avi" || $icon eq "rm" ||$icon eq "mpg" || $icon eq "MOV" ||$icon eq "AVI" || $icon eq "RM" ||$icon eq "MPG")
{$icon_t = "$icon_url/mpg.gif";}
elsif ($icon eq "reg" ||$icon eq "REG")
{$icon_t = "$icon_url/reg.gif";}
elsif ($icon eq "hlp" ||$icon eq "chm" || $icon eq "HLP" ||$icon eq "CHM")
{$icon_t = "$icon_url/hlp.gif";}
elsif ($icon eq "cgi" ||$icon eq "php" || $icon eq "pm" || $icon eq "asp" || $icon eq "CGI" ||$icon eq "PHP" || $icon eq "PM" || $icon eq "ASP")
{$icon_t = "$icon_url/cgi.gif";}
elsif ($icon eq "zip" ||$icon eq "rar" || $icon eq "tar" || $icon eq "arj" || $icon eq "lzh" ||$icon eq "ace" || $icon eq "ZIP" ||$icon eq "RAR" || $icon eq "TAR" || $icon eq "ARJ" || $icon eq "LZH" ||$icon eq "ACE")
{$icon_t = "$icon_url/zip.gif";}
else { $icon_t = "$icon_url/unknow.gif";}
return $icon_t;
}

sub password_encording{
    local($st) = @_;
    local($make);
	local(@set);
	@set = ('a'..'z','A'..'Z','0'..'9','.','/');
	$make = "$set[9]$set[3]";
    return crypt($st,$make);
	
}

sub time_mode
{
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    $month = ($mon + 1);
	if ($min   <= 9)  { $min = "0".$min;      }
	if ($hour  <= 9)  { $hour = "0".$hour;    }
	if ($mday  <= 9)  { $mday = "0".$mday;    }
	if ($month <= 9)  { $month = "0".$month;  }
	     $year += 1900;
	     $time[0] = "$month/$mday"; 
	     $time[1] = "$month/$mday/$year.$hour:$min:$sec"; 
	     $time[2] = "$month/$mday/$year,$hour:$min:$sec";
	     $time[3] = "$month $mday $hour $min"; 
	return @time;
}
#----------------------------------------------------------------#
sub cookie_mode{
if($ENV{'HTTP_COOKIE'}) {
	@cookie = split(/; /,$ENV{'HTTP_COOKIE'});
	foreach(@cookie) {
	($Name,$Value) = split(/=/,$_);
	$ck{$Name} = $Value;
	}
	}
	}

sub getinput{
$Method = $ENV{'REQUEST_METHOD'};
if ($Method eq "GET") {
	$buffer = $ENV{'QUERY_STRING'};
	@pair = split (/&/, $buffer);
	foreach $NameValue (@pair) {
		($name, $value) = split(/=/,$NameValue); 
		$value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C",hex($1))/eg;
		$form{$name} = $value;
		}
  	    }
}
sub postinput{
if ($Method eq "POST") {
    @hid=();
	@list=();
	$content_type = $ENV{'CONTENT_TYPE'};
    $content_length = $ENV{'CONTENT_LENGTH'};
    binmode STDIN;
    read(STDIN,$buffer,$content_length);
   if((!$content_type) ||($content_type eq 'application/x-www-form-urlencoded')) {
	@pair = split (/&/, $buffer);
	foreach $NameValue (@pair)
	{
		$i++;
		($name, $value) = split (/=/,$NameValue);
		$value =~tr/+/ /;
		$value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C",hex($1))/eg;
		$hid[$i] = $name;
		$list[$i] = $value;
		$form{$name} = $value;
	}
   }
elsif($content_type =~ m#^multipart/form-data#) {
($boundary = $content_type) =~ s/^.*boundary=(.*)$/\1/;
@pairs = split(/--$boundary/, $buffer);
@pairs = splice(@pairs,1,$#pairs-1);
$file_count = 0;
for $pair (@pairs)  {
($dump,$line,$value) = split(/\r\n/,$pair,3);
if($line =~ /filename/) {
$gRealFile[$file_count] = $line;
$file_count++;
}
next if $line =~ /filename=\"\"/;
$line =~ s/^Content-Disposition: form-data; //;
(@column) = split(/;\s+/, $line);
($name = $column[0]) =~ s/^name="([^"]+)"$/\1/g;
if($#column > 0) { 
if($value =~ /^Content-Type:/)  {
($dump,$dump,$value) = split(/\r\n/,$value,3);
}
else {
($dump,$value) = split(/\r\n/,$value,2);
}
}
else {
($dump,$value) = split(/\r\n/,$value,2);
if(grep(/^$name$/, keys(%CGI))) {
if(@{$form{$name}} > 0) {
push(@{$form{$name}}, $value);
}
else { 
$array_value = $form{$name};
undef $form{$name};
$form{$name}[0] = $array_value;
push(@{$form{$name}}, $value);
}
}
else {
next if $value =~ /^\s*$/;
$form{$name} = $value;
chop($form{$name});
chop($form{$name});
}
next;
}
$form{$name} = $value;
}
}
}
}

1;